## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.10

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XalanAttr Class Reference

`#include <XalanAttr.hpp>`

Inheritance diagram for XalanAttr:

[legend]
Collaboration diagram for XalanAttr:

[legend]
List of all members.

## Public Methods

- XalanAttr ()
- virtual ~XalanAttr ()
- virtual const XalanDOMString& getNodeName () const=0
- virtual const XalanDOMString& getNodeValue () const=0
    Gets the value of this node, depending on its type. More...
- virtual NodeType getNodeType () const=0
    An enum value representing the type of the underlying object. More...
- virtual XalanNode* getParentNode () const=0
    Gets the parent of this node. More...
- virtual const XalanNodeList* getChildNodes () const=0
    Gets a `NodeList` that contains all children of this node. More...
- virtual XalanNode* getFirstChild () const=0
    Gets the first child of this node. More...
- virtual XalanNode* getLastChild () const=0
    Gets the last child of this node. More...
- virtual XalanNode* getPreviousSibling () const=0
    Gets the node immediately preceding this node. More...
- virtual XalanNode* getNextSibling () const=0
    Gets the node immediately following this node. More...
- virtual const XalanNamedNodeMap* getAttributes () const=0
    Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. More...
- virtual XalanDocument* getOwnerDocument () const=0
    Gets the `Document` object associated with this node. More...

Cloning function.

- virtual XalanAttr* cloneNode (bool deep) const=0
    Returns a duplicate of this node. More...

Functions to modify the DOM Node.

- virtual XalanNode* insertBefore (XalanNode *newChild, XalanNode *refChild)=0
    Inserts the node `newChild` before the existing child node `refChild`. More...
- virtual XalanNode* replaceChild (XalanNode *newChild, XalanNode *oldChild)=0
    Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. More...
- virtual XalanNode* removeChild (XalanNode *oldChild)=0
    Removes the child node indicated by `oldChild` from the list of children, and returns it. More...
- virtual XalanNode* appendChild (XalanNode *newChild)=0
    Adds the node `newChild` to the end of the list of children of this node. More...

Query functions.

- virtual bool hasChildNodes () const=0
    This is a convenience method to allow easy determination of whether a node has any children. More...

Set functions.

- virtual void setNodeValue (const XalanDOMString &nodeValue)=0
    Sets the value of the node. More...

Functions introduced in DOM Level 2.

- virtual void normalize ()=0
    Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. More...
- virtual bool isSupported (const XalanDOMString &feature, const XalanDOMString &version) const=0
    Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. More...
- virtual const XalanDOMString& getNamespaceURI () const=0
    Get the namespace URI of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getPrefix () const=0
    Get the namespace prefix of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getLocalName () const=0
    Returns the local part of the qualified name of this node. More...
- virtual void setPrefix (const XalanDOMString &prefix)=0
    Set the namespace prefix of this node. More...
- virtual bool isIndexed () const=0
    Determine if the document is node-order indexed. More...
- virtual IndexType getIndex () const=0
    Get the node's index. More...

Getter functions

- virtual const XalanDOMString& getName () const=0
    Returns the name of this attribute. More...
- virtual bool getSpecified () const=0
    Returns true if the attribute received its value explicitly in the XML document, or if a value was assigned programatically with the setValue function. More...
- virtual const XalanDOMString& getValue () const=0
    Returns the value of the attribute. More...

Setter functions

- virtual void setValue (const XalanDOMString &value)=0
    Sets the value of the attribute. More...

Functions introduced in DOM Level 2.

- virtual XalanElement* getOwnerElement () const=0
    The `Element` node this attribute is attached to or `null` if this attribute is not in use. More...

## Protected Methods

- XalanAttr (const XalanAttr &theSource)
- XalanAttr& operator= (const XalanAttr &theSource)
- bool operator== (const XalanAttr &theRHS) const

## Constructor & Destructor Documentation

XalanAttr::XalanAttr ( | )

XalanAttr::~XalanAttr ( | )`[virtual]`

XalanAttr::XalanAttr ( | const XalanAttr & theSource )`[protected]`

## Member Function Documentation

XalanNode * XalanAttr::appendChild ( | XalanNode * newChild )`[pure virtual]`

Adds the node `newChild` to the end of the list of children of this node.

If the `newChild` is already in the tree, it is first removed.

Parameters:

  newChild | The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node

Returns:
  The node added.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanAttr * XalanAttr::cloneNode ( | bool deep ) const`[pure virtual]`

Returns a duplicate of this node.

This function serves as a generic copy constructor for nodes.

The duplicate node has no parent ( `parentNode` returns `null`.).
Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node.

Parameters:

  deep | If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).

Returns:
  The duplicate node.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XalanSourceTreeAttrNS, XercesAttrWrapper, and XercesAttrBridge.

const XalanNamedNodeMap * XalanAttr::getAttributes ( | ) const`[pure virtual]`

| Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

const XalanNodeList * XalanAttr::getChildNodes ( | ) const`[pure virtual]`

Gets a `NodeList` that contains all children of this node.

If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList`, including the ones returned by the `getElementsByTagName` method.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanNode * XalanAttr::getFirstChild ( | ) const`[pure virtual]`

| Gets the first child of this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

IndexType XalanAttr::getIndex ( | ) const`[pure virtual]`

Get the node's index.

Valid only if the owner document reports that the document is node-order indexed.

Returns:
  The index value, or 0 if the node is not indexed.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanNode * XalanAttr::getLastChild ( | ) const`[pure virtual]`

| Gets the last child of this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

const XalanDOMString & XalanAttr::getLocalName ( | ) const`[pure virtual]`

| Returns the local part of the qualified name of this node. For nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, it is null. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XalanSourceTreeAttrNS, XercesAttrWrapper, and XercesAttrBridge.

const XalanDOMString & XalanAttr::getName ( | ) const`[pure virtual]`

| Returns the name of this attribute. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

const XalanDOMString & XalanAttr::getNamespaceURI ( | ) const`[pure virtual]`

Get the namespace URI of this node, or `null` if it is unspecified.

This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.

For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XalanSourceTreeAttrNS, XercesAttrWrapper, and XercesAttrBridge.

XalanNode * XalanAttr::getNextSibling ( | ) const`[pure virtual]`

| Gets the node immediately following this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

const XalanDOMString & XalanAttr::getNodeName ( | ) const`[pure virtual]`

| Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

NodeType XalanAttr::getNodeType ( | ) const`[pure virtual]`

| An enum value representing the type of the underlying object. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

const XalanDOMString & XalanAttr::getNodeValue ( | ) const`[pure virtual]`

| Gets the value of this node, depending on its type. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanDocument * XalanAttr::getOwnerDocument ( | ) const`[pure virtual]`

| Gets the `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanElement * XalanAttr::getOwnerElement ( | ) const`[pure virtual]`

| The `Element` node this attribute is attached to or `null` if this attribute is not in use. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanNode * XalanAttr::getParentNode ( | ) const`[pure virtual]`

| Gets the parent of this node. All nodes, except `Document`, `DocumentFragment`, and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, a `null` Node is returned. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

const XalanDOMString & XalanAttr::getPrefix ( | ) const`[pure virtual]`

| Get the namespace prefix of this node, or `null` if it is unspecified. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XalanSourceTreeAttrNS, XercesAttrWrapper, and XercesAttrBridge.

XalanNode * XalanAttr::getPreviousSibling ( | ) const`[pure virtual]`

| Gets the node immediately preceding this node. If there is no such node, this returns `null`. Reimplemented from XalanNode. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

bool XalanAttr::getSpecified ( | ) const`[pure virtual]`

| Returns true if the attribute received its value explicitly in the XML document, or if a value was assigned programatically with the setValue function. Returns false if the attribute value came from the default value declared in the document's DTD. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

const XalanDOMString & XalanAttr::getValue ( | ) const`[pure virtual]`

| Returns the value of the attribute. The value of the attribute is returned as a string. Character and general entity references are replaced with their values. Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

bool XalanAttr::hasChildNodes ( | ) const`[pure virtual]`

This is a convenience method to allow easy determination of whether a node has any children.

Returns:
  `true` if the node has any children, `false` if the node has no children.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanNode * XalanAttr::insertBefore ( | XalanNode * newChild,
| XalanNode * refChild )`[pure virtual]`

Inserts the node `newChild` before the existing child node `refChild`.

If `refChild` is `null`, insert `newChild` at the end of the list of children.
If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed. Note that a `Node` that has never been assigned to refer to an actual node is == null.

Parameters:

  newChild | The node to insert.
  refChild | The reference node, i.e., the node before which the new node must be inserted.

Returns:
  The node being inserted.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

bool XalanAttr::isIndexed ( | ) const`[pure virtual]`

Determine if the document is node-order indexed.

Returns:
  true if the document is indexed, otherwise false.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

bool XalanAttr::isSupported ( | const XalanDOMString & feature,
| const XalanDOMString & version ) const`[pure virtual]`

Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

Parameters:

  feature | The string of the feature to test. This is the same name as what can be passed to the method `hasFeature` on `DOMImplementation`.
  version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.

Returns:
  Returns `true` if the specified feature is supported on this node, `false` otherwise.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

void XalanAttr::normalize ( | )`[pure virtual]`

Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes.

This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.

Note: In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanAttr & XalanAttr::operator= ( | const XalanAttr & theSource )`[protected]`

bool XalanAttr::operator== ( | const XalanAttr & theRHS ) const`[protected]`

XalanNode * XalanAttr::removeChild ( | XalanNode * oldChild )`[pure virtual]`

Removes the child node indicated by `oldChild` from the list of children, and returns it.

Parameters:

  oldChild | The node being removed.

Returns:
  The node removed.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

XalanNode * XalanAttr::replaceChild ( | XalanNode * newChild,
| XalanNode * oldChild )`[pure virtual]`

Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.

If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order.

If the `newChild` is already in the tree, it is first removed.

Parameters:

  newChild | The new node to put in the child list.
  oldChild | The node being replaced in the list.

Returns:
  The node replaced.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

void XalanAttr::setNodeValue ( | const XalanDOMString & nodeValue )`[pure virtual]`

Sets the value of the node.

Any node which can have a nodeValue (

See also:
  getNodeValue) will also accept requests to set it to a string. The exact response to this varies from node to node -- Attribute, for example, stores its values in its children and has to replace them with a new Text holding the replacement value.

For most types of Node, value is null and attempting to set it will throw DOMException(NO_MODIFICATION_ALLOWED_ERR). This will also be thrown if the node is read-only.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

void XalanAttr::setPrefix ( | const XalanDOMString & prefix )`[pure virtual]`

Set the namespace prefix of this node.

Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.

Note also that changing the prefix of an attribute, that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.

Parameters:

  prefix | The prefix of this node.

Exceptions:

  DOMException

  INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character.
  NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
  NAMESPACE_ERR: Raised if the specified `prefix` is malformed, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if specified prefix is "xmlns" and the `namespaceURI` is neither `null` nor an empty string, or if the `localName` is `null`.

Reimplemented from XalanNode.

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

void XalanAttr::setValue ( | const XalanDOMString & value )`[pure virtual]`

Sets the value of the attribute.

A text node with the unparsed contents of the string will be created.

Parameters:

  value | The value of the DOM attribute to be set

Reimplemented in XalanSourceTreeAttr, XercesAttrWrapper, and XercesAttrBridge.

The documentation for this class was generated from the following file:

- XalanAttr.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.10 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.